// D import file generated from 'derelict/assimp3/assimp.d'
module derelict.assimp3.assimp;
public import derelict.assimp3.types;
private 
{
	import derelict.util.loader;
	import derelict.util.system;
	static if (Derelict_OS_Windows)
	{
		static if (size_t.sizeof == 4)
		{
			enum libNames = "assimp.dll, Assimp32.dll";
		}
		else
		{
			static if (size_t.sizeof == 8)
			{
				enum libNames = "assimp.dll, Assimp64.dll";
			}
			else
			{
				static assert(0);
			}
		}
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "libassimp.3.dylib";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libassimp.so.3, libassimp.so.3.0.0";
			}
			else
			{
				static assert(0, "Need to implement ASSIMP3 libNames for this operating system.");
			}
		}
	}
}
aiReturn aiGetMaterialFloat(const(aiMaterial)* mat, const(char)* key, uint type, uint index, float* _out);
aiReturn aiGetMaterialInteger(const(aiMaterial)* mat, const(char)* key, uint type, uint index, int* _out);
extern (C) nothrow 
{
	alias da_aiGetExportFormatCount = size_t function();
	alias da_aiGetExportFormatDescription = aiExportFormatDesc* function(size_t);
	alias da_aiCopyScene = void function(const(aiScene)*, aiScene**);
	alias da_aiExportScene = aiReturn function(const(aiScene)*, const(char)*, const(char)*, uint);
	alias da_aiExportSceneEx = aiReturn function(const(aiScene)*, const(char)*, const(char)*, aiFileIO*, uint);
	alias da_aiExportSceneToBlob = const(aiExportDataBlob)* function(const(aiScene)*, const(char)*, uint);
	alias da_aiReleaseExportBlob = void function(const(aiExportDataBlob)*);
	alias da_aiImportFile = const(aiScene*) function(const(char)*, uint);
	alias da_aiImportFileEx = const(aiScene*) function(const(char)*, uint, aiFileIO*);
	alias da_aiImportFileExWithProperties = const(aiScene*) function(const(char)*, uint, aiFileIO*, const(aiPropertyStore)*);
	alias da_aiImportFileFromMemory = const(aiScene*) function(const(void)*, uint, uint, const(char)*);
	alias da_aiImportFileFromMemoryWithProperties = const(aiScene*) function(const(void)*, uint, uint, const(char)*, const(aiPropertyStore)*);
	alias da_aiApplyPostProcessing = const(aiScene*) function(const(aiScene*), uint);
	alias da_aiGetPredefinedLogStream = aiLogStream function(aiDefaultLogStream, const(char)*);
	alias da_aiAttachLogStream = void function(const(aiLogStream)*);
	alias da_aiEnableVerboseLogging = void function(aiBool);
	alias da_aiDetachLogStream = aiReturn function(const(aiLogStream)*);
	alias da_aiDetachAllLogStreams = void function();
	alias da_aiReleaseImport = void function(const(aiScene)*);
	alias da_aiGetErrorString = const(char)* function();
	alias da_aiIsExtensionSupported = aiBool function(const(char)*);
	alias da_aiGetExtensionList = void function(aiString*);
	alias da_aiGetMemoryRequirements = void function(const(aiScene)*, aiMemoryInfo*);
	alias da_aiCreatePropertyStore = aiPropertyStore* function();
	alias da_aiReleasePropertyStore = void function(aiPropertyStore*);
	alias da_aiSetImportPropertyInteger = void function(aiPropertyStore*, const(char)*, int);
	alias da_aiSetImportPropertyFloat = void function(aiPropertyStore*, const(char)*, float);
	alias da_aiSetImportPropertyString = void function(aiPropertyStore*, const(char)*, const(aiString)*);
	alias da_aiCreateQuaternionFromMatrix = void function(aiQuaternion*, const(aiMatrix3x3)*);
	alias da_aiDecomposeMatrix = void function(const(aiMatrix4x4)*, aiVector3D*, aiQuaternion*, aiVector3D*);
	alias da_aiTransposeMatrix4 = void function(aiMatrix4x4*);
	alias da_aiTransposeMatrix3 = void function(aiMatrix3x3*);
	alias da_aiTransformVecByMatrix3 = void function(aiVector3D*, const(aiMatrix3x3)*);
	alias da_aiTransformVecByMatrix4 = void function(aiVector3D*, const(aiMatrix4x4)*);
	alias da_aiMultiplyMatrix4 = void function(aiMatrix4x4*, const(aiMatrix4x4)*);
	alias da_aiMultiplyMatrix3 = void function(aiMatrix3x3*, const(aiMatrix3x3)*);
	alias da_aiIdentityMatrix3 = void function(aiMatrix3x3*);
	alias da_aiIdentityMatrix4 = void function(aiMatrix4x4*);
	alias da_aiGetMaterialProperty = aiReturn function(const(aiMaterial)*, const(char)*, uint, uint, aiMaterialProperty**);
	alias da_aiGetMaterialFloatArray = aiReturn function(const(aiMaterial)*, const(char)*, uint, uint, float*, uint*);
	alias da_aiGetMaterialIntegerArray = aiReturn function(const(aiMaterial)*, const(char)*, uint, uint, int*, uint*);
	alias da_aiGetMaterialColor = aiReturn function(const(aiMaterial)*, const(char)*, uint, uint, aiColor4D*);
	alias da_aiGetMaterialString = aiReturn function(const(aiMaterial)*, const(char)*, uint, uint, aiString*);
	alias da_aiGetMaterialTextureCount = uint function(const(aiMaterial)*, aiTextureType);
	alias da_aiGetMaterialTexture = aiReturn function(const(aiMaterial)*, aiTextureType, uint, aiString*, aiTextureMapping* m = null, uint* uvindex = null, float* blend = null, aiTextureOp* op = null, aiTextureMapMode* mm = null, uint* flags = null);
	alias da_aiGetLegalString = nothrow const(char)* function();
	alias da_aiGetVersionMinor = nothrow uint function();
	alias da_aiGetVersionMajor = nothrow uint function();
	alias da_aiGetVersionRevision = nothrow uint function();
	alias da_aiGetCompileFlags = nothrow uint function();
}
__gshared 
{
	da_aiGetExportFormatCount aiGetExportFormatCount;
	da_aiGetExportFormatDescription aiGetExportFormatDescription;
	da_aiCopyScene aiCopyScene;
	da_aiExportScene aiExportScene;
	da_aiExportSceneEx aiExportSceneEx;
	da_aiExportSceneToBlob aiExportSceneToBlob;
	da_aiReleaseExportBlob aiReleaseExportBlob;
	da_aiImportFile aiImportFile;
	da_aiImportFileEx aiImportFileEx;
	da_aiImportFileExWithProperties aiImportFileExWithProperties;
	da_aiImportFileFromMemory aiImportFileFromMemory;
	da_aiImportFileFromMemoryWithProperties aiImportFileFromMemoryWithProperties;
	da_aiApplyPostProcessing aiApplyPostProcessing;
	da_aiGetPredefinedLogStream aiGetPredefinedLogStream;
	da_aiAttachLogStream aiAttachLogStream;
	da_aiEnableVerboseLogging aiEnableVerboseLogging;
	da_aiDetachLogStream aiDetachLogStream;
	da_aiDetachAllLogStreams aiDetachAllLogStreams;
	da_aiReleaseImport aiReleaseImport;
	da_aiGetErrorString aiGetErrorString;
	da_aiIsExtensionSupported aiIsExtensionSupported;
	da_aiGetExtensionList aiGetExtensionList;
	da_aiGetMemoryRequirements aiGetMemoryRequirements;
	da_aiCreatePropertyStore aiCreatePropertyStore;
	da_aiReleasePropertyStore aiReleasePropertyStore;
	da_aiSetImportPropertyInteger aiSetImportPropertyInteger;
	da_aiSetImportPropertyFloat aiSetImportPropertyFloat;
	da_aiSetImportPropertyString aiSetImportPropertyString;
	da_aiCreateQuaternionFromMatrix aiCreateQuaternionFromMatrix;
	da_aiDecomposeMatrix aiDecomposeMatrix;
	da_aiTransposeMatrix4 aiTransposeMatrix4;
	da_aiTransposeMatrix3 aiTransposeMatrix3;
	da_aiTransformVecByMatrix3 aiTransformVecByMatrix3;
	da_aiTransformVecByMatrix4 aiTransformVecByMatrix4;
	da_aiMultiplyMatrix4 aiMultiplyMatrix4;
	da_aiMultiplyMatrix3 aiMultiplyMatrix3;
	da_aiIdentityMatrix3 aiIdentityMatrix3;
	da_aiIdentityMatrix4 aiIdentityMatrix4;
	da_aiGetMaterialProperty aiGetMaterialProperty;
	da_aiGetMaterialFloatArray aiGetMaterialFloatArray;
	da_aiGetMaterialIntegerArray aiGetMaterialIntegerArray;
	da_aiGetMaterialColor aiGetMaterialColor;
	da_aiGetMaterialString aiGetMaterialString;
	da_aiGetMaterialTextureCount aiGetMaterialTextureCount;
	da_aiGetMaterialTexture aiGetMaterialTexture;
	da_aiGetLegalString aiGetLegalString;
	da_aiGetVersionMinor aiGetVersionMinor;
	da_aiGetVersionMajor aiGetVersionMajor;
	da_aiGetVersionRevision aiGetVersionRevision;
	da_aiGetCompileFlags aiGetCompileFlags;
}
class DerelictASSIMP3Loader : SharedLibLoader
{
	public this();
	protected override void loadSymbols();
}
__gshared DerelictASSIMP3Loader DerelictASSIMP3;
shared static this();
